
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>PostgreSQL 百亿数据 秒级响应 正则及模糊查询 / iVAN</title>

    <meta name="description" content="PostgreSQL 百亿数据 秒级响应 正则及模糊查询 正则匹配和模糊匹配通常是搜索引擎的特长,但是如果你使用的是 PostgreSQL 数据库照样能实现,并且性能不赖,加上分布式方案 (譬如 plproxy, pg_shard, fdw shard, pg-xc, pg-xl, greenplum),处理百亿以上数据量的正则匹配和模糊匹配效果杠杠的,同时还不失数据库固有的功能,一举多得. 物联网中有大量的数据,除了数字数据,还有字符串类的数据,例如条形码,车牌,手机号,邮箱,姓名等等. 假设用户需要在大量的传感数据中进行模糊检索,甚至规则表达式匹配">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">PostgreSQL 百亿数据 秒级响应 正则及模糊查询</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>正则匹配和模糊匹配通常是搜索引擎的特长，但是如果你使用的是 PostgreSQL 数据库照样能实现，并且性能不赖，加上分布式方案 (譬如 plproxy, pg_shard, fdw shard, pg-xc, pg-xl, greenplum)，处理百亿以上数据量的正则匹配和模糊匹配效果杠杠的，同时还不失数据库固有的功能，一举多得。</p>
<p>物联网中有大量的数据，除了数字数据，还有字符串类的数据，例如条形码，车牌，手机号，邮箱，姓名等等。<br />
假设用户需要在大量的传感数据中进行模糊检索，甚至规则表达式匹配，有什么高效的方法呢？<br />
这种场景还挺多，例如市面上发现了一批药品可能有问题，需要对药品条码进行规则表达式查找，找出复合条件的药品流向。<br />
又比如在侦查行动时，线索的检索，如用户提供的残缺的电话号码，邮箱，车牌，IP地址，QQ号码，微信号码等等。<br />
根据这些信息加上时间的叠加，模糊匹配和关联，最终找出罪犯。<br />
可以看出，模糊匹配，正则表达式匹配，和人脸拼图有点类似，需求非常的迫切。</p>
<p>首先对应用场景进行一下分类，以及现有技术下能使用的优化手段。<br />
.1. 带前缀的模糊查询，例如 like 'ABC%'，在PG中也可以写成 ~ '^ABC'<br />
可以使用btree索引优化，或者拆列用多列索引叠加bit and或bit or进行优化（只适合固定长度的端字符串，例如char(8)）。</p>
<p>.2. 带后缀的模糊查询，例如 like '%ABC'，在PG中也可以写成 ~ 'ABC$'<br />
可以使用reverse函数btree索引，或者拆列用多列索引叠加bit and或bit or进行优化（只适合固定长度的端字符串，例如char(8)）。</p>
<p>.3. 不带前缀和后缀的模糊查询，例如 like '%AB_C%'，在PG中也可以写成 ~ 'AB.C'<br />
可以使用pg_trgm的gin索引，或者拆列用多列索引叠加bit and或bit or进行优化（只适合固定长度的端字符串，例如char(8)）。</p>
<p>.4. 正则表达式查询，例如 ~ '[\d]+def1.?[a|b|0|8]{1,3}'<br />
可以使用pg_trgm的gin索引，或者拆列用多列索引叠加bit and或bit or进行优化（只适合固定长度的端字符串，例如char(8)）。</p>
<p>PostgreSQL pg_trgm插件自从9.1开始支持模糊查询使用索引，从9.3开始支持规则表达式查询使用索引，大大提高了PostgreSQL在刑侦方面的能力。<br />
代码见<br /><a href="https://github.com/postgrespro/pg_trgm_pro" rel="external nofollow noreferrer">https://github.com/postgrespro/pg_trgm_pro</a></p>
<p>pg_trgm插件的原理，将字符串前加2个空格，后加1个空格，组成一个新的字符串，并将这个新的字符串按照每3个相邻的字符拆分成多个token。<br />
当使用规则表达式或者模糊查询进行匹配时，会检索出他们的近似度，再进行filter。<br />
GIN索引的图例：<br /><a href="http://img2.tbcdn.cn/L1/461/1/d7231924b0038504f43a1481f8fb31e1a5676b01.jpeg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMi50YmNkbi5jbi9MMS80NjEvMS9kNzIzMTkyNGIwMDM4NTA0ZjQzYTE0ODFmOGZiMzFlMWE1Njc2YjAxLmpwZWc=.jpg"></a><br />
从btree检索到匹配的token时，指向对应的list, 从list中存储的ctid找到对应的记录。<br />
因为一个字符串会拆成很多个token，所以没插入一条记录，会更新多条索引，这也是GIN索引需要fastupdate的原因。<br />
正则匹配是怎么做到的呢？<br />
详见 <a href="https://raw.githubusercontent.com/postgrespro/pg_trgm_pro/master/trgm_regexp.c" rel="external nofollow noreferrer">https://raw.githubusercontent.com/postgrespro/pg_trgm_pro/master/trgm_regexp.c</a><br />
实际上它是将正则表达式转换成了NFA格式，然后扫描多个TOKEN，进行bit and|or匹配。<br />
正则组合如果转换出来的的bit and|or很多的话，就需要大量的recheck，性能也不能好到哪里去。</p>
<p>下面针对以上四种场景，实例讲解如何优化。</p>
<p>.1. 带前缀的模糊查询，例如 like 'ABC%'，在PG中也可以写成 ~ '^ABC'<br />
可以使用btree索引优化，或者拆列用多列索引叠加bit and或bit or进行优化（只适合固定长度的端字符串，例如char(8)）。<br />
例子，1000万随机产生的MD5数据的前8个字符。</p>
<pre><code>postgres=# create table tb(info text);
CREATE TABLE
postgres=# insert into tb select substring(md5(random()::text),1,8) from generate_series(1,10000000);
INSERT 0 10000000
postgres=# create index idx_tb on tb(info);
CREATE INDEX
postgres=# select * from tb limit 1;
   info
----------
 376821ab
(1 row)
postgres=# explain select * from tb where info ~ '^376821' limit 10;
                                  QUERY PLAN
-------------------------------------------------------------------------------
 Limit  (cost=0.43..0.52 rows=10 width=9)
   -&gt;  Index Only Scan using idx_tb on tb  (cost=0.43..8.46 rows=1000 width=9)
         Index Cond: ((info &gt;= '376821'::text) AND (info &lt; '376822'::text))
         Filter: (info ~ '^376821'::text)
(4 rows)
postgres=# select * from tb where info ~ '^376821' limit 10;
   info
----------
 376821ab
(1 row)
Time: 0.536 ms
postgres=# set enable_indexscan=off;
SET
Time: 1.344 ms
postgres=# set enable_bitmapscan=off;
SET
Time: 0.158 ms
postgres=# explain select * from tb where info ~ '^376821' limit 10;
                           QUERY PLAN
----------------------------------------------------------------
 Limit  (cost=0.00..1790.55 rows=10 width=9)
   -&gt;  Seq Scan on tb  (cost=0.00..179055.00 rows=1000 width=9)
         Filter: (info ~ '^376821'::text)
(3 rows)
Time: 0.505 ms
</code></pre>
<p>带前缀的模糊查询，不使用索引需要5483毫秒。<br />
带前缀的模糊查询，使用索引只需要0.5毫秒。</p>
<pre><code>postgres=# select * from tb where info ~ '^376821' limit 10;
   info
----------
 376821ab
(1 row)
Time: 5483.655 ms
</code></pre>
<p>.2. 带后缀的模糊查询，例如 like '%ABC'，在PG中也可以写成 ~ 'ABC$'<br />
可以使用reverse函数btree索引，或者拆列用多列索引叠加bit and或bit or进行优化（只适合固定长度的端字符串，例如char(8)）。</p>
<pre><code>postgres=# create index idx_tb1 on tb(reverse(info));
CREATE INDEX
postgres=# explain select * from tb where reverse(info) ~ '^ba128' limit 10;
                                         QUERY PLAN
--------------------------------------------------------------------------------------------
 Limit  (cost=0.43..28.19 rows=10 width=9)
   -&gt;  Index Scan using idx_tb1 on tb  (cost=0.43..138778.43 rows=50000 width=9)
         Index Cond: ((reverse(info) &gt;= 'ba128'::text) AND (reverse(info) &lt; 'ba129'::text))
         Filter: (reverse(info) ~ '^ba128'::text)
(4 rows)  

postgres=# select * from tb where reverse(info) ~ '^ba128' limit 10;
   info
----------
 220821ab
 671821ab
 305821ab
 e65821ab
 536821ab
 376821ab
 668821ab
 4d8821ab
 26c821ab
(9 rows)
Time: 0.506 ms
</code></pre>
<p>带后缀的模糊查询，使用索引只需要0.5毫秒。</p>
<p>.3. 不带前缀和后缀的模糊查询，例如 like '%AB_C%'，在PG中也可以写成 ~ 'AB.C'<br />
可以使用pg_trgm的gin索引，或者拆列用多列索引叠加bit and或bit or进行优化（只适合固定长度的端字符串，例如char(8)）。</p>
<pre><code>postgres=# create extension pg_trgm;
postgres=# explain select * from tb where info ~ '5821a';
                                 QUERY PLAN
----------------------------------------------------------------------------
 Bitmap Heap Scan on tb  (cost=103.75..3677.71 rows=1000 width=9)
   Recheck Cond: (info ~ '5821a'::text)
   -&gt;  Bitmap Index Scan on idx_tb_2  (cost=0.00..103.50 rows=1000 width=0)
         Index Cond: (info ~ '5821a'::text)
(4 rows)
Time: 0.647 ms  

postgres=# select * from tb where info ~ '5821a';
   info
----------
 5821a8a3
 945821af
 45821a74
 9fe5821a
 5821a7e0
 5821af2a
 1075821a
 e5821ac9
 d265821a
 45f5821a
 df5821a4
 de5821af
 71c5821a
 375821a3
 fc5821af
 5c5821ad
 e65821ab
 5821adde
 c35821a6
 5821a642
 305821ab
 5821a1c8
 75821a5c
 ce95821a
 a65821ad
(25 rows)
Time: 3.808 ms
</code></pre>
<p>前后模糊查询，使用索引只需要3.8毫秒。</p>
<p>.4. 正则表达式查询，例如 ~ '[\d]+def1.?[a|b|0|8]{1,3}'<br />
可以使用pg_trgm的gin索引，或者拆列用多列索引叠加bit and或bit or进行优化（只适合固定长度的端字符串，例如char(8)）。</p>
<p>前后模糊查询，使用索引只需要108毫秒。</p>
<pre><code>postgres=# select * from tb where info ~ 'e65[\d]{2}a[b]{1,2}8' limit 10;
   info
----------
 4e6567ab
 1e6530ab
 e6500ab8
 ae6583ab
 e6564ab7
 5e6532ab
 e6526abf
 e6560ab6
(8 rows)
Time: 108.577 ms
</code></pre>
<p>时间主要花费在排他上面。<br />
检索了14794行，remove了14793行。大量的时间花费在无用功上，但是比全表扫还是好很多。</p>
<pre><code>postgres=# explain (verbose,analyze,buffers,costs,timing) select * from tb where info ~ 'e65[\d]{2}a[b]{1,2}8' limit 10;
                                                            QUERY PLAN
----------------------------------------------------------------------------------------------------------------------------------
 Limit  (cost=511.75..547.49 rows=10 width=9) (actual time=89.934..120.567 rows=1 loops=1)
   Output: info
   Buffers: shared hit=13054
   -&gt;  Bitmap Heap Scan on public.tb  (cost=511.75..4085.71 rows=1000 width=9) (actual time=89.930..120.562 rows=1 loops=1)
         Output: info
         Recheck Cond: (tb.info ~ 'e65[\d]{2}a[b]{1,2}8'::text)
         Rows Removed by Index Recheck: 14793
         Heap Blocks: exact=12929
         Buffers: shared hit=13054
         -&gt;  Bitmap Index Scan on idx_tb_2  (cost=0.00..511.50 rows=1000 width=0) (actual time=67.589..67.589 rows=14794 loops=1)
               Index Cond: (tb.info ~ 'e65[\d]{2}a[b]{1,2}8'::text)
               Buffers: shared hit=125
 Planning time: 0.493 ms
 Execution time: 120.618 ms
(14 rows)
Time: 124.693 ms
</code></pre>
<p>优化：<br />
使用gin索引后，需要考虑性能问题，因为info字段被打散成了多个char(3)的token，从而涉及到非常多的索引条目，如果有非常高并发的插入，最好把gin_pending_list_limit设大，来提高插入效率，降低实时合并索引带来的RT升高。<br />
使用了fastupdate后，会在每次vacuum表时，自动将pengding的信息合并到GIN索引中。<br />
还有一点，查询不会有合并的动作，对于没有合并的GIN信息是使用遍历的方式搜索的。</p>
<p>压测高并发的性能：</p>
<pre><code>create table tbl(id serial8, crt_time timestamp, sensorid int, sensorloc point, info text) with (autovacuum_enabled=on, autovacuum_vacuum_threshold=0.000001,autovacuum_vacuum_cost_delay=0);
CREATE INDEX trgm_idx ON tbl USING GIN (info gin_trgm_ops) with (fastupdate='on', gin_pending_list_limit='6553600');
alter sequence tbl_id_seq cache 10000;
</code></pre>
<p>修改配置，让数据库的autovacuum快速迭代合并gin。</p>
<pre><code>vi $PGDATA/postgresql.conf
autovacuum_naptime=1s
maintenance_work_mem=1GB
autovacuum_work_mem=1GB
autovacuum = on
autovacuum_max_workers = 3
log_autovacuum_min_duration = 0
autovacuum_vacuum_cost_delay=0  

$ pg_ctl reload
</code></pre>
<p>创建一个测试函数，用来产生随机的测试数据。</p>
<pre><code>postgres=# create or replace function f() returns void as $$
  insert into tbl (crt_time,sensorid,info) values ( clock_timestamp(),trunc(random()*500000),substring(md5(random()::text),1,8) );
$$ language sql strict;  

vi test.sql
select f();  

pgbench -M prepared -n -r -P 1 -f ./test.sql -c 48 -j 48 -T 10000  

progress: 50.0 s, 52800.9 tps, lat 0.453 ms stddev 0.390
progress: 51.0 s, 52775.8 tps, lat 0.453 ms stddev 0.398
progress: 52.0 s, 53173.2 tps, lat 0.449 ms stddev 0.371
progress: 53.0 s, 53010.0 tps, lat 0.451 ms stddev 0.390
progress: 54.0 s, 53360.9 tps, lat 0.448 ms stddev 0.365
progress: 55.0 s, 53285.0 tps, lat 0.449 ms stddev 0.362
progress: 56.0 s, 53662.1 tps, lat 0.445 ms stddev 0.368
progress: 57.0 s, 53283.8 tps, lat 0.448 ms stddev 0.385
progress: 58.0 s, 53703.4 tps, lat 0.445 ms stddev 0.355
progress: 59.0 s, 53818.7 tps, lat 0.444 ms stddev 0.344
progress: 60.0 s, 53889.2 tps, lat 0.443 ms stddev 0.361
progress: 61.0 s, 53613.8 tps, lat 0.446 ms stddev 0.355
progress: 62.0 s, 53339.9 tps, lat 0.448 ms stddev 0.392
progress: 63.0 s, 54014.9 tps, lat 0.442 ms stddev 0.346
progress: 64.0 s, 53112.1 tps, lat 0.450 ms stddev 0.374
progress: 65.0 s, 53706.1 tps, lat 0.445 ms stddev 0.367
progress: 66.0 s, 53720.9 tps, lat 0.445 ms stddev 0.353
progress: 67.0 s, 52858.1 tps, lat 0.452 ms stddev 0.415
progress: 68.0 s, 53218.9 tps, lat 0.449 ms stddev 0.387
progress: 69.0 s, 53403.0 tps, lat 0.447 ms stddev 0.377
progress: 70.0 s, 53179.9 tps, lat 0.449 ms stddev 0.377
progress: 71.0 s, 53232.4 tps, lat 0.449 ms stddev 0.373
progress: 72.0 s, 53011.7 tps, lat 0.451 ms stddev 0.386
progress: 73.0 s, 52685.1 tps, lat 0.454 ms stddev 0.384
progress: 74.0 s, 52937.8 tps, lat 0.452 ms stddev 0.377
</code></pre>
<p>按照这个速度，一天能支持超过40亿数据入库。</p>
<p>接下来对比一下字符串分离的例子，这个例子适用于字符串长度固定，并且很小的场景，如果字符串长度不固定，这种方法没用。<br />
适用splict的方法，测试数据不尽人意，所以还是用pg_trgm比较靠谱。</p>
<pre><code>postgres=# create table t_split(id int, crt_time timestamp, sensorid int, sensorloc point, info text, c1 char(1), c2 char(1), c3 char(1), c4 char(1), c5 char(1), c6 char(1), c7 char(1), c8 char(1));
CREATE TABLE
Time: 2.123 ms  

postgres=# insert into t_split(id,crt_time,sensorid,info,c1,c2,c3,c4,c5,c6,c7,c8) select id,ct,sen,info,substring(info,1,1),substring(info,2,1),substring(info,3,1),substring(info,4,1),substring(info,5,1),substring(info,6,1),substring(info,7,1),substring(info,8,1) from (select id, clock_timestamp() ct, trunc(random()*500000) sen, substring(md5(random()::text), 1, 8) info from generate_series(1,10000000) t(id)) t;
INSERT 0 10000000
Time: 81829.274 ms  

postgres=# create index idx1 on t_split (c1);
postgres=# create index idx2 on t_split (c2);
postgres=# create index idx3 on t_split (c3);
postgres=# create index idx4 on t_split (c4);
postgres=# create index idx5 on t_split (c5);
postgres=# create index idx6 on t_split (c6);
postgres=# create index idx7 on t_split (c7);
postgres=# create index idx8 on t_split (c8);
postgres=# create index idx9 on t_split using gin (info gin_trgm_ops);  

postgres=# select * from t_split limit 1;
 id |          crt_time          | sensorid | sensorloc |   info   | c1 | c2 | c3 | c4 | c5 | c6 | c7 | c8
----+----------------------------+----------+-----------+----------+----+----+----+----+----+----+----+----
  1 | 2016-03-02 09:58:03.990639 |   161958 |           | 33eed779 | 3  | 3  | e  | e  | d  | 7  | 7  | 9
(1 row)  

postgres=# select * from t_split where info ~ '^3[\d]?eed[\d]?79$' limit 10;
 id |          crt_time          | sensorid | sensorloc |   info   | c1 | c2 | c3 | c4 | c5 | c6 | c7 | c8
----+----------------------------+----------+-----------+----------+----+----+----+----+----+----+----+----
  1 | 2016-03-02 09:58:03.990639 |   161958 |           | 33eed779 | 3  | 3  | e  | e  | d  | 7  | 7  | 9
(1 row)
Time: 133.041 ms
postgres=# explain (analyze,verbose,timing,costs,buffers) select * from t_split where info ~ '^3[\d]?eed[\d]?79$' limit 10;
                                                            QUERY PLAN
----------------------------------------------------------------------------------------------------------------------------------
 Limit  (cost=575.75..612.78 rows=10 width=57) (actual time=92.406..129.838 rows=1 loops=1)
   Output: id, crt_time, sensorid, sensorloc, info, c1, c2, c3, c4, c5, c6, c7, c8
   Buffers: shared hit=13798
   -&gt;  Bitmap Heap Scan on public.t_split  (cost=575.75..4278.56 rows=1000 width=57) (actual time=92.403..129.833 rows=1 loops=1)
         Output: id, crt_time, sensorid, sensorloc, info, c1, c2, c3, c4, c5, c6, c7, c8
         Recheck Cond: (t_split.info ~ '^3[\d]?eed[\d]?79$'::text)
         Rows Removed by Index Recheck: 14690
         Heap Blocks: exact=13669
         Buffers: shared hit=13798
         -&gt;  Bitmap Index Scan on idx9  (cost=0.00..575.50 rows=1000 width=0) (actual time=89.576..89.576 rows=14691 loops=1)
               Index Cond: (t_split.info ~ '^3[\d]?eed[\d]?79$'::text)
               Buffers: shared hit=129
 Planning time: 0.385 ms
 Execution time: 129.883 ms
(14 rows)  

Time: 130.678 ms  

postgres=# select * from t_split where c1='3' and c3='e' and c4='e' and c5='d' and c7='7' and c8='9' and c2 between '0' and '9' and c6 between '0' and '9' limit 10;
 id |          crt_time          | sensorid | sensorloc |   info   | c1 | c2 | c3 | c4 | c5 | c6 | c7 | c8
----+----------------------------+----------+-----------+----------+----+----+----+----+----+----+----+----
  1 | 2016-03-02 09:58:03.990639 |   161958 |           | 33eed779 | 3  | 3  | e  | e  | d  | 7  | 7  | 9
(1 row)  

Time: 337.367 ms  

postgres=# explain (analyze,verbose,timing,costs,buffers) select * from t_split where c1='3' and c3='e' and c4='e' and c5='d' and c7='7' and c8='9' and c2 between '0' and '9' and c6 between '0' and '9' limit 10;
                                                                                                                 QUERY PLAN
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 Limit  (cost=33582.31..41499.35 rows=1 width=57) (actual time=339.230..344.675 rows=1 loops=1)
   Output: id, crt_time, sensorid, sensorloc, info, c1, c2, c3, c4, c5, c6, c7, c8
   Buffers: shared hit=7581
   -&gt;  Bitmap Heap Scan on public.t_split  (cost=33582.31..41499.35 rows=1 width=57) (actual time=339.228..344.673 rows=1 loops=1)
         Output: id, crt_time, sensorid, sensorloc, info, c1, c2, c3, c4, c5, c6, c7, c8
         Recheck Cond: ((t_split.c3 = 'e'::bpchar) AND (t_split.c8 = '9'::bpchar) AND (t_split.c5 = 'd'::bpchar))
         Filter: ((t_split.c2 &gt;= '0'::bpchar) AND (t_split.c2 &lt;= '9'::bpchar) AND (t_split.c6 &gt;= '0'::bpchar) AND (t_split.c6 &lt;= '9'::bpchar) AND (t_split.c1 = '3'::bpchar) AND (t_split.c4 = 'e'::bpchar) AND (t_split.c7 = '7'::bpchar))
         Rows Removed by Filter: 2480
         Heap Blocks: exact=2450
         Buffers: shared hit=7581
         -&gt;  BitmapAnd  (cost=33582.31..33582.31 rows=2224 width=0) (actual time=338.512..338.512 rows=0 loops=1)
               Buffers: shared hit=5131
               -&gt;  Bitmap Index Scan on idx3  (cost=0.00..11016.93 rows=596333 width=0) (actual time=104.418..104.418 rows=624930 loops=1)
                     Index Cond: (t_split.c3 = 'e'::bpchar)
                     Buffers: shared hit=1711
               -&gt;  Bitmap Index Scan on idx8  (cost=0.00..11245.44 rows=608667 width=0) (actual time=100.185..100.185 rows=625739 loops=1)
                     Index Cond: (t_split.c8 = '9'::bpchar)
                     Buffers: shared hit=1712
               -&gt;  Bitmap Index Scan on idx5  (cost=0.00..11319.44 rows=612667 width=0) (actual time=99.480..99.480 rows=624269 loops=1)
                     Index Cond: (t_split.c5 = 'd'::bpchar)
                     Buffers: shared hit=1708
 Planning time: 0.262 ms
 Execution time: 344.731 ms
(23 rows)  

Time: 346.424 ms  

postgres=# select * from t_split where info ~ '^33.+7.+9$' limit 10;
   id   |          crt_time          | sensorid | sensorloc |   info   | c1 | c2 | c3 | c4 | c5 | c6 | c7 | c8
--------+----------------------------+----------+-----------+----------+----+----+----+----+----+----+----+----
      1 | 2016-03-02 09:58:03.990639 |   161958 |           | 33eed779 | 3  | 3  | e  | e  | d  | 7  | 7  | 9
  24412 | 2016-03-02 09:58:04.186359 |   251599 |           | 33f07429 | 3  | 3  | f  | 0  | 7  | 4  | 2  | 9
  24989 | 2016-03-02 09:58:04.191112 |   214569 |           | 334587d9 | 3  | 3  | 4  | 5  | 8  | 7  | d  | 9
  50100 | 2016-03-02 09:58:04.398499 |   409819 |           | 33beb7b9 | 3  | 3  | b  | e  | b  | 7  | b  | 9
  92623 | 2016-03-02 09:58:04.745372 |   280100 |           | 3373e719 | 3  | 3  | 7  | 3  | e  | 7  | 1  | 9
 106054 | 2016-03-02 09:58:04.855627 |   155192 |           | 33c575c9 | 3  | 3  | c  | 5  | 7  | 5  | c  | 9
 107070 | 2016-03-02 09:58:04.863827 |   464325 |           | 337dd729 | 3  | 3  | 7  | d  | d  | 7  | 2  | 9
 135152 | 2016-03-02 09:58:05.088217 |   240500 |           | 336271d9 | 3  | 3  | 6  | 2  | 7  | 1  | d  | 9
 156425 | 2016-03-02 09:58:05.25805  |   218202 |           | 333e7289 | 3  | 3  | 3  | e  | 7  | 2  | 8  | 9
 170210 | 2016-03-02 09:58:05.368371 |   132530 |           | 33a8d789 | 3  | 3  | a  | 8  | d  | 7  | 8  | 9
(10 rows)  

Time: 20.431 ms  

postgres=# explain (analyze,verbose,timing,costs,buffers) select * from t_split where info ~ '^33.+7.+9$' limit 10;
                                                           QUERY PLAN
---------------------------------------------------------------------------------------------------------------------------------
 Limit  (cost=43.75..80.78 rows=10 width=57) (actual time=19.573..21.212 rows=10 loops=1)
   Output: id, crt_time, sensorid, sensorloc, info, c1, c2, c3, c4, c5, c6, c7, c8
   Buffers: shared hit=566
   -&gt;  Bitmap Heap Scan on public.t_split  (cost=43.75..3746.56 rows=1000 width=57) (actual time=19.571..21.206 rows=10 loops=1)
         Output: id, crt_time, sensorid, sensorloc, info, c1, c2, c3, c4, c5, c6, c7, c8
         Recheck Cond: (t_split.info ~ '^33.+7.+9$'::text)
         Rows Removed by Index Recheck: 647
         Heap Blocks: exact=552
         Buffers: shared hit=566
         -&gt;  Bitmap Index Scan on idx9  (cost=0.00..43.50 rows=1000 width=0) (actual time=11.712..11.712 rows=39436 loops=1)
               Index Cond: (t_split.info ~ '^33.+7.+9$'::text)
               Buffers: shared hit=14
 Planning time: 0.301 ms
 Execution time: 21.255 ms
(14 rows)  

Time: 21.995 ms  

postgres=# select * from t_split where c1='3' and c2='3' and c8='9' and (c4='7' or c5='7' or c6='7') limit 10;
   id   |          crt_time          | sensorid | sensorloc |   info   | c1 | c2 | c3 | c4 | c5 | c6 | c7 | c8
--------+----------------------------+----------+-----------+----------+----+----+----+----+----+----+----+----
      1 | 2016-03-02 09:58:03.990639 |   161958 |           | 33eed779 | 3  | 3  | e  | e  | d  | 7  | 7  | 9
  24412 | 2016-03-02 09:58:04.186359 |   251599 |           | 33f07429 | 3  | 3  | f  | 0  | 7  | 4  | 2  | 9
  24989 | 2016-03-02 09:58:04.191112 |   214569 |           | 334587d9 | 3  | 3  | 4  | 5  | 8  | 7  | d  | 9
  50100 | 2016-03-02 09:58:04.398499 |   409819 |           | 33beb7b9 | 3  | 3  | b  | e  | b  | 7  | b  | 9
  92623 | 2016-03-02 09:58:04.745372 |   280100 |           | 3373e719 | 3  | 3  | 7  | 3  | e  | 7  | 1  | 9
 106054 | 2016-03-02 09:58:04.855627 |   155192 |           | 33c575c9 | 3  | 3  | c  | 5  | 7  | 5  | c  | 9
 107070 | 2016-03-02 09:58:04.863827 |   464325 |           | 337dd729 | 3  | 3  | 7  | d  | d  | 7  | 2  | 9
 135152 | 2016-03-02 09:58:05.088217 |   240500 |           | 336271d9 | 3  | 3  | 6  | 2  | 7  | 1  | d  | 9
 156425 | 2016-03-02 09:58:05.25805  |   218202 |           | 333e7289 | 3  | 3  | 3  | e  | 7  | 2  | 8  | 9
 170210 | 2016-03-02 09:58:05.368371 |   132530 |           | 33a8d789 | 3  | 3  | a  | 8  | d  | 7  | 8  | 9
(10 rows)  

Time: 37.739 ms  

postgres=# explain (analyze,verbose,timing,costs,buffers) select * from t_split where c1='3' and c2='3' and c8='9' and (c4='7' or c5='7' or c6='7') limit 10;
                                                                                               QUERY PLAN
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 Limit  (cost=0.00..8135.78 rows=10 width=57) (actual time=0.017..35.532 rows=10 loops=1)
   Output: id, crt_time, sensorid, sensorloc, info, c1, c2, c3, c4, c5, c6, c7, c8
   Buffers: shared hit=1755
   -&gt;  Seq Scan on public.t_split  (cost=0.00..353093.00 rows=434 width=57) (actual time=0.015..35.526 rows=10 loops=1)
         Output: id, crt_time, sensorid, sensorloc, info, c1, c2, c3, c4, c5, c6, c7, c8
         Filter: ((t_split.c1 = '3'::bpchar) AND (t_split.c2 = '3'::bpchar) AND (t_split.c8 = '9'::bpchar) AND ((t_split.c4 = '7'::bpchar) OR (t_split.c5 = '7'::bpchar) OR (t_split.c6 = '7'::bpchar)))
         Rows Removed by Filter: 170200
         Buffers: shared hit=1755
 Planning time: 0.210 ms
 Execution time: 35.572 ms
(10 rows)  

Time: 36.260 ms  

postgres=# select * from t_split where info ~ '^3.?[b-g]+ed[\d]+79' order by info &lt;-&gt; '^3.?[b-g]+ed[\d]+79' limit 10;
   id    |          crt_time          | sensorid | sensorloc |   info   | c1 | c2 | c3 | c4 | c5 | c6 | c7 | c8
---------+----------------------------+----------+-----------+----------+----+----+----+----+----+----+----+----
       1 | 2016-03-02 09:58:03.990639 |   161958 |           | 33eed779 | 3  | 3  | e  | e  | d  | 7  | 7  | 9
 1308724 | 2016-03-02 09:58:14.590901 |   458822 |           | 3fed9479 | 3  | f  | e  | d  | 9  | 4  | 7  | 9
 2866024 | 2016-03-02 09:58:27.20105  |   106467 |           | 3fed2279 | 3  | f  | e  | d  | 2  | 2  | 7  | 9
 4826729 | 2016-03-02 09:58:42.907431 |   228023 |           | 3ded9879 | 3  | d  | e  | d  | 9  | 8  | 7  | 9
 6113373 | 2016-03-02 09:58:53.211146 |   499702 |           | 36fed479 | 3  | 6  | f  | e  | d  | 4  | 7  | 9
 1768237 | 2016-03-02 09:58:18.310069 |   345027 |           | 30fed079 | 3  | 0  | f  | e  | d  | 0  | 7  | 9
 1472324 | 2016-03-02 09:58:15.913629 |   413283 |           | 3eed5798 | 3  | e  | e  | d  | 5  | 7  | 9  | 8
 8319056 | 2016-03-02 09:59:10.902137 |   336740 |           | 3ded7790 | 3  | d  | e  | d  | 7  | 7  | 9  | 0
 8576573 | 2016-03-02 09:59:12.962923 |   130223 |           | 3eed5793 | 3  | e  | e  | d  | 5  | 7  | 9  | 3
(9 rows)  

Time: 268.661 ms  

postgres=# explain (analyze,verbose,timing,buffers,costs) select * from t_split where info ~ '^3.?[b-g]+ed[\d]+79' order by info &lt;-&gt; '^3.?[b-g]+ed[\d]+79' limit 10;
                                                               QUERY PLAN
-----------------------------------------------------------------------------------------------------------------------------------------
 Limit  (cost=4302.66..4302.69 rows=10 width=57) (actual time=269.214..269.217 rows=9 loops=1)
   Output: id, crt_time, sensorid, sensorloc, info, c1, c2, c3, c4, c5, c6, c7, c8, ((info &lt;-&gt; '^3.?[b-g]+ed[\d]+79'::text))
   Buffers: shared hit=52606
   -&gt;  Sort  (cost=4302.66..4305.16 rows=1000 width=57) (actual time=269.212..269.212 rows=9 loops=1)
         Output: id, crt_time, sensorid, sensorloc, info, c1, c2, c3, c4, c5, c6, c7, c8, ((info &lt;-&gt; '^3.?[b-g]+ed[\d]+79'::text))
         Sort Key: ((t_split.info &lt;-&gt; '^3.?[b-g]+ed[\d]+79'::text))
         Sort Method: quicksort  Memory: 26kB
         Buffers: shared hit=52606
         -&gt;  Bitmap Heap Scan on public.t_split  (cost=575.75..4281.06 rows=1000 width=57) (actual time=100.771..269.180 rows=9 loops=1)
               Output: id, crt_time, sensorid, sensorloc, info, c1, c2, c3, c4, c5, c6, c7, c8, (info &lt;-&gt; '^3.?[b-g]+ed[\d]+79'::text)
               Recheck Cond: (t_split.info ~ '^3.?[b-g]+ed[\d]+79'::text)
               Rows Removed by Index Recheck: 72929
               Heap Blocks: exact=52479
               Buffers: shared hit=52606
               -&gt;  Bitmap Index Scan on idx9  (cost=0.00..575.50 rows=1000 width=0) (actual time=88.062..88.062 rows=72938 loops=1)
                     Index Cond: (t_split.info ~ '^3.?[b-g]+ed[\d]+79'::text)
                     Buffers: shared hit=127
 Planning time: 0.640 ms
 Execution time: 269.287 ms
(19 rows)  

Time: 270.430 ms  

postgres=# select * from t_split where info ~ '3.?[b-g]+ed[\d]+79' order by info &lt;-&gt; '3.?[b-g]+ed[\d]+79' limit 10;
   id    |          crt_time          | sensorid | sensorloc |   info   | c1 | c2 | c3 | c4 | c5 | c6 | c7 | c8
---------+----------------------------+----------+-----------+----------+----+----+----+----+----+----+----+----
       1 | 2016-03-02 09:58:03.990639 |   161958 |           | 33eed779 | 3  | 3  | e  | e  | d  | 7  | 7  | 9
 1308724 | 2016-03-02 09:58:14.590901 |   458822 |           | 3fed9479 | 3  | f  | e  | d  | 9  | 4  | 7  | 9
 4826729 | 2016-03-02 09:58:42.907431 |   228023 |           | 3ded9879 | 3  | d  | e  | d  | 9  | 8  | 7  | 9
 5250603 | 2016-03-02 09:58:46.300289 |   250582 |           | d3eed179 | d  | 3  | e  | e  | d  | 1  | 7  | 9
 6113373 | 2016-03-02 09:58:53.211146 |   499702 |           | 36fed479 | 3  | 6  | f  | e  | d  | 4  | 7  | 9
 1768237 | 2016-03-02 09:58:18.310069 |   345027 |           | 30fed079 | 3  | 0  | f  | e  | d  | 0  | 7  | 9
 2866024 | 2016-03-02 09:58:27.20105  |   106467 |           | 3fed2279 | 3  | f  | e  | d  | 2  | 2  | 7  | 9
 1472324 | 2016-03-02 09:58:15.913629 |   413283 |           | 3eed5798 | 3  | e  | e  | d  | 5  | 7  | 9  | 8
 8576573 | 2016-03-02 09:59:12.962923 |   130223 |           | 3eed5793 | 3  | e  | e  | d  | 5  | 7  | 9  | 3
 8319056 | 2016-03-02 09:59:10.902137 |   336740 |           | 3ded7790 | 3  | d  | e  | d  | 7  | 7  | 9  | 0
(10 rows)  

Time: 320.525 ms  

postgres=# explain (analyze,verbose,buffers,costs,timing) select * from t_split where info ~ '3.?[b-g]+ed[\d]+79' order by info &lt;-&gt; '3.?[b-g]+ed[\d]+79' limit 10;
                                                                QUERY PLAN
------------------------------------------------------------------------------------------------------------------------------------------
 Limit  (cost=4302.66..4302.69 rows=10 width=57) (actual time=319.925..319.927 rows=10 loops=1)
   Output: id, crt_time, sensorid, sensorloc, info, c1, c2, c3, c4, c5, c6, c7, c8, ((info &lt;-&gt; '3.?[b-g]+ed[\d]+79'::text))
   Buffers: shared hit=52602
   -&gt;  Sort  (cost=4302.66..4305.16 rows=1000 width=57) (actual time=319.923..319.923 rows=10 loops=1)
         Output: id, crt_time, sensorid, sensorloc, info, c1, c2, c3, c4, c5, c6, c7, c8, ((info &lt;-&gt; '3.?[b-g]+ed[\d]+79'::text))
         Sort Key: ((t_split.info &lt;-&gt; '3.?[b-g]+ed[\d]+79'::text))
         Sort Method: quicksort  Memory: 26kB
         Buffers: shared hit=52602
         -&gt;  Bitmap Heap Scan on public.t_split  (cost=575.75..4281.06 rows=1000 width=57) (actual time=104.526..319.885 rows=10 loops=1)
               Output: id, crt_time, sensorid, sensorloc, info, c1, c2, c3, c4, c5, c6, c7, c8, (info &lt;-&gt; '3.?[b-g]+ed[\d]+79'::text)
               Recheck Cond: (t_split.info ~ '3.?[b-g]+ed[\d]+79'::text)
               Rows Removed by Index Recheck: 72928
               Heap Blocks: exact=52479
               Buffers: shared hit=52602
               -&gt;  Bitmap Index Scan on idx9  (cost=0.00..575.50 rows=1000 width=0) (actual time=91.945..91.945 rows=72938 loops=1)
                     Index Cond: (t_split.info ~ '3.?[b-g]+ed[\d]+79'::text)
                     Buffers: shared hit=123
 Planning time: 0.948 ms
 Execution time: 320.003 ms
(19 rows)  

Time: 321.502 ms
</code></pre>
<p>大数据量性能测试：<br />
模拟分区表，每小时一个分区，每小时数据量5000万，一天12亿，一个月360亿。</p>
<pre><code>drop table tbl cascade;
create table tbl (id serial8, crt_time timestamp, sensorid int, sensorloc point, info text);  

do language plpgsql $$
declare
  v_s timestamp := '2016-01-01 00:00:00';
begin
  for i in 1..720 loop
    execute 'create table tbl_'||to_char(v_s,'yyyymmddhh24')||' (id int8 not null default nextval(''tbl_id_seq''::regclass), crt_time timestamp check (crt_time &gt;= '''||to_char(v_s,'yyyy-mm-dd hh24:mi:ss')||''' and crt_time &lt;'''||to_char(v_s+'1 h'::interval,'yyyy-mm-dd hh24:mi:ss')||'''), sensorid int, sensorloc point, info text) inherits (tbl)';
    v_s := v_s + '1 h'::interval;
  end loop;
end;
$$;  

alter sequence tbl_id_seq cache 100000;
</code></pre>
<p>生成插入SQL</p>
<pre><code>do language plpgsql $$
declare
  v_s timestamp := '2016-01-01 00:00:00';
begin
  for i in 1..720 loop
    raise notice '%', 'psql -c "insert into tbl_'||to_char(v_s,'yyyymmddhh24')||' (crt_time, sensorid, info) select '''||to_char(v_s,'yyyy-mm-dd hh24:mi:ss')||''',trunc(random()*500000), substring(md5(random()::text),1,8) from generate_series(1,50000000);" &amp;';
    v_s := v_s + '1 h'::interval;
  end loop;
end;
$$;
</code></pre>
<p>性能指标, 范围扫描, 落到单表5000万的数据量内, 毫秒级返回.</p>
<pre><code>postgres=# explain (analyze,verbose,timing,buffers,costs) select * from tbl where crt_time between '2016-01-01 12:00:00' and '2016-01-01 12:30:00' and info ~ 'f[\d]{2}e27e0$' order by info &lt;-&gt; 'f[\d]{2}e27e0$' limit 10;
                                                                                                        QUERY PLAN
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 Limit  (cost=18918.83..18918.85 rows=10 width=45) (actual time=350.296..350.297 rows=2 loops=1)
   Output: tbl.id, tbl.crt_time, tbl.sensorid, tbl.sensorloc, tbl.info, ((tbl.info &lt;-&gt; 'f[\d]{2}e27e0$'::text))
   Buffers: shared hit=4530
   -&gt;  Sort  (cost=18918.83..18931.33 rows=5001 width=45) (actual time=350.294..350.295 rows=2 loops=1)
         Output: tbl.id, tbl.crt_time, tbl.sensorid, tbl.sensorloc, tbl.info, ((tbl.info &lt;-&gt; 'f[\d]{2}e27e0$'::text))
         Sort Key: ((tbl.info &lt;-&gt; 'f[\d]{2}e27e0$'::text))
         Sort Method: quicksort  Memory: 25kB
         Buffers: shared hit=4530
         -&gt;  Result  (cost=0.00..18810.76 rows=5001 width=45) (actual time=347.995..350.279 rows=2 loops=1)
               Output: tbl.id, tbl.crt_time, tbl.sensorid, tbl.sensorloc, tbl.info, (tbl.info &lt;-&gt; 'f[\d]{2}e27e0$'::text)
               Buffers: shared hit=4530
               -&gt;  Append  (cost=0.00..18798.26 rows=5001 width=45) (actual time=347.976..350.254 rows=2 loops=1)
                     Buffers: shared hit=4530
                     -&gt;  Seq Scan on public.tbl  (cost=0.00..0.00 rows=1 width=68) (actual time=0.001..0.001 rows=0 loops=1)
                           Output: tbl.id, tbl.crt_time, tbl.sensorid, tbl.sensorloc, tbl.info
                           Filter: ((tbl.crt_time &gt;= '2016-01-01 12:00:00'::timestamp without time zone) AND (tbl.crt_time &lt;= '2016-01-01 12:30:00'::timestamp without time zone) AND (tbl.info ~ 'f[\d]{2}e27e0$'::text))
                     -&gt;  Bitmap Heap Scan on public.tbl_2016010112  (cost=574.75..18798.26 rows=5000 width=45) (actual time=347.972..350.249 rows=2 loops=1)
                           Output: tbl_2016010112.id, tbl_2016010112.crt_time, tbl_2016010112.sensorid, tbl_2016010112.sensorloc, tbl_2016010112.info
                           Recheck Cond: (tbl_2016010112.info ~ 'f[\d]{2}e27e0$'::text)
                           Rows Removed by Index Recheck: 4100
                           Filter: ((tbl_2016010112.crt_time &gt;= '2016-01-01 12:00:00'::timestamp without time zone) AND (tbl_2016010112.crt_time &lt;= '2016-01-01 12:30:00'::timestamp without time zone))
                           Heap Blocks: exact=4085
                           Buffers: shared hit=4530
                           -&gt;  Bitmap Index Scan on idx_tbl_2016010112  (cost=0.00..573.50 rows=5000 width=0) (actual time=337.125..337.125 rows=4102 loops=1)
                                 Index Cond: (tbl_2016010112.info ~ 'f[\d]{2}e27e0$'::text)
                                 Buffers: shared hit=445
 Planning time: 23.913 ms
 Execution time: 350.383 ms
(28 rows)  

postgres=# select * from tbl where crt_time between '2016-01-01 12:00:00' and '2016-01-01 12:30:00' and info ~ 'f[\d]{2}e27e0$' order by info &lt;-&gt; 'f[\d]{2}e27e0$' limit 10;
     id     |      crt_time       | sensorid | sensorloc |   info
------------+---------------------+----------+-----------+----------
 1982100172 | 2016-01-01 12:00:00 |   336772 |           | f48e27e0
 2292713691 | 2016-01-01 12:00:00 |   489110 |           | f77e27e0
(2 rows)
</code></pre>
<p>单表144亿的正则和模糊查询性能测试：</p>
<pre><code>postgres=# \dt+ t_all
                    List of relations
 Schema | Name  | Type  |  Owner   |  Size  | Description
--------+-------+-------+----------+--------+-------------
 public | t_all | table | postgres | 811 GB |
(1 row)  

postgres=# \d t_all
                Table "public.t_all"
  Column   |            Type             | Modifiers
-----------+-----------------------------+-----------
 id        | bigint                      | not null
 crt_time  | timestamp without time zone |
 sensorid  | integer                     |
 sensorloc | point                       |
 info      | text                        |   

postgres=# select count(*) from t_all;
    count
-------------
 14456717312
(1 row)  

postgres=# select * from t_all limit 10;
     id     |      crt_time       | sensorid | sensorloc |   info
------------+---------------------+----------+-----------+----------
 6519272065 | 2016-01-06 10:00:00 |   493013 |           | 62255c83
 6519272066 | 2016-01-06 10:00:00 |   309676 |           | f6c98800
 6519272067 | 2016-01-06 10:00:00 |    43859 |           | 125a1191
 6519272068 | 2016-01-06 10:00:00 |   495624 |           | e75cfd71
 6519272069 | 2016-01-06 10:00:00 |    10362 |           | 7171f11c
 6519272070 | 2016-01-06 10:00:00 |   231476 |           | 4201f809
 6519272071 | 2016-01-06 10:00:00 |    43080 |           | a47e84e5
 6519272072 | 2016-01-06 10:00:00 |   131292 |           | 17bc248e
 6519272073 | 2016-01-06 10:00:00 |   486841 |           | 3303097c
 6519272074 | 2016-01-06 10:00:00 |   491503 |           | f0c53fee
(10 rows)
</code></pre>
<p>测试数据后续放出，分表后做到秒级是没有问题的。信心从何而来呢？<br />
因为瓶颈不在IO上，主要在数据的recheck, 把144亿数据拆分成29个5亿的表，并行执行，秒出是有可能的。</p>
<p>来看一个单表5亿的测试结果，秒出：</p>
<pre><code>postgres=# explain (verbose,analyze,buffers,timing,costs) select * from tbl1 where info ~ 'aad.+f02' limit 10;
                                                               QUERY PLAN
-----------------------------------------------------------------------------------------------------------------------------------------
 Limit  (cost=1439.79..1476.19 rows=10 width=29) (actual time=116.570..116.719 rows=10 loops=1)
   Output: id, crt_time, sensorid, info
   Buffers: shared hit=680
   -&gt;  Bitmap Heap Scan on public.tbl1  (cost=1439.79..191054.88 rows=52103 width=29) (actual time=116.568..116.716 rows=10 loops=1)
         Output: id, crt_time, sensorid, info
         Recheck Cond: (tbl1.info ~ 'aad.+f02'::text)
         Rows Removed by Index Recheck: 38
         Heap Blocks: exact=48
         Buffers: shared hit=680
         -&gt;  Bitmap Index Scan on tbl1_info_idx  (cost=0.00..1426.77 rows=52103 width=0) (actual time=116.495..116.495 rows=403 loops=1)
               Index Cond: (tbl1.info ~ 'aad.+f02'::text)
               Buffers: shared hit=632
 Planning time: 0.311 ms
 Execution time: 116.754 ms
(14 rows)

Time: 117.422 ms
postgres=# select * from tbl1 where info ~ 'aad.+f02' limit 10;
    id     |          crt_time          | sensorid |   info
-----------+----------------------------+----------+----------
  17986922 | 2016-02-29 17:42:42.427639 |    75863 | aad3f02a
  19873247 | 2016-02-29 17:43:16.714945 |   174971 | 2aad5f02
  23798336 | 2016-02-29 17:44:35.369654 |   202085 | aad06f02
  28630866 | 2016-02-29 17:46:03.544462 |   463184 | baad3f02
  31458529 | 2016-02-29 17:47:00.300937 |   411670 | aad1af02
  52009687 | 2016-02-29 17:53:15.466246 |   192821 | 5aad6f02
  80769909 | 2016-02-29 18:01:31.074248 |    47993 | aadcf029
  80825896 | 2016-02-29 18:01:31.039063 |   284712 | aad14f02
  83385996 | 2016-02-29 18:02:12.699317 |    78233 | daadcf02
 102814316 | 2016-02-29 18:08:20.891412 |   359635 | aad06f02
(10 rows)

Time: 116.901 ms
</code></pre>
<p>全表扫描需要,</p>
<pre><code>postgres=# set enable_bitmapscan=off;
SET
Time: 0.145 ms
postgres=# select * from tbl1 where info ~ 'aad.+f02' limit 10;
    id     |          crt_time          | sensorid |   info
-----------+----------------------------+----------+----------
  31458529 | 2016-02-29 17:47:00.300937 |   411670 | aad1af02
  52009687 | 2016-02-29 17:53:15.466246 |   192821 | 5aad6f02
  80769909 | 2016-02-29 18:01:31.074248 |    47993 | aadcf029
  80825896 | 2016-02-29 18:01:31.039063 |   284712 | aad14f02
  83385996 | 2016-02-29 18:02:12.699317 |    78233 | daadcf02
 102814316 | 2016-02-29 18:08:20.891412 |   359635 | aad06f02
 105236847 | 2016-02-29 18:09:56.914795 |      876 | aadbf026
 108524272 | 2016-02-29 18:10:47.39312  |   338071 | 2aad2f02
 128169786 | 2016-02-29 18:17:52.105948 |   262400 | aad0f028
 135935810 | 2016-02-29 18:20:43.265139 |   487673 | aad7f021
(10 rows)
Time: 98903.073 ms
</code></pre>
<p>性能对比图表：<br />
1000万数据对比<br /><a href="http://img1.tbcdn.cn/L1/461/1/84a668003cb63776a1fbb9a1e000f3f569b1b88f.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS50YmNkbi5jbi9MMS80NjEvMS84NGE2NjgwMDNjYjYzNzc2YTFmYmI5YTFlMDAwZjNmNTY5YjFiODhmLnBuZw==.jpg"></a><br />
5亿数据对比<br /><a href="http://img1.tbcdn.cn/L1/461/1/b5a1a53bb02bac582c48368ec46c8ec86f8dff3d.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS50YmNkbi5jbi9MMS80NjEvMS9iNWExYTUzYmIwMmJhYzU4MmM0ODM2OGVjNDZjOGVjODZmOGRmZjNkLnBuZw==.jpg"></a><br />
1000万数据btree bit or|and与gin对比<br /><a href="http://img2.tbcdn.cn/L1/461/1/975b16cf59b5131e2141702936b51d4bb2f5e649.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMi50YmNkbi5jbi9MMS80NjEvMS85NzViMTZjZjU5YjUxMzFlMjE0MTcwMjkzNmI1MWQ0YmIyZjVlNjQ5LnBuZw==.jpg"></a><br />
144亿分区表对比<br /><a href="http://img1.tbcdn.cn/L1/461/1/a05b70e7b4ae817ec65280d2e8e7237e82d1fc06.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS50YmNkbi5jbi9MMS80NjEvMS9hMDViNzBlN2I0YWU4MTdlYzY1MjgwZDJlOGU3MjM3ZTgyZDFmYzA2LnBuZw==.jpg"></a></p>
<p>大数据量的优化方法，例如百亿级别以上的数据量，如何能做到秒级的模糊查询响应。<br />
对于单机，可以使用分区，同时使用并行查询，充分使用CPU的功能。<br />
或者使用MPP, SHARDING架构，利用多机的资源。</p>
<p>原则，减少recheck，尽量扫描搜索到最终需要的结果（大量扫描，大量remove checked false row, 全表和索引都存在这种现象）</p>
<p>[补充]<br />
.1. 测试用的主机配置简单描述<br />
普通x86, 24核，1xxG 内存，SSD硬盘。</p>
<p>.2. 收到了一位朋友的疑问，<br />
德哥,首先要问你一个问题, 为什么你使用md5 前8位生成 数据 ? md5 最小位数就是16位 , 你这样做究竟有什么数学原因导致要前8位字符?</p>
<p>回复如下：<br />
首先MD5计算的结果是一个128bit的hex，PostgreSQL将结果以文本的形式输出，所以看到的是32位长度的字符串，</p>
<pre><code>rfc1321

3.1 Step 1. Append Padding Bits
3.2 Step 2. Append Length
3.3 Step 3. Initialize MD Buffer
3.4 Step 4. Process Message in 16-Word Blocks
3.5 Step 5. Output

4. Summary
   The MD5 message-digest algorithm is simple to implement, and provides
   a "fingerprint" or message digest of a message of arbitrary length.
   It is conjectured that the difficulty of coming up with two messages
   having the same message digest is on the order of 2^64 operations,
   and that the difficulty of coming up with any message having a given
   message digest is on the order of 2^128 operations. The MD5 algorithm
   has been carefully scrutinized for weaknesses. It is, however, a
   relatively new algorithm and further security analysis is of course
   justified, as is the case with any new proposal of this sort.

PG代码
/*
 * Create an md5 hash of a text string and return it as hex
 *
 * md5 produces a 16 byte (128 bit) hash; double it for hex
 */
#define MD5_HASH_LEN  32

Datum
md5_text(PG_FUNCTION_ARGS)
{
    text       *in_text = PG_GETARG_TEXT_PP(0);
    size_t      len;
    char        hexsum[MD5_HASH_LEN + 1];

    /* Calculate the length of the buffer using varlena metadata */
    len = VARSIZE_ANY_EXHDR(in_text);

    /* get the hash result */
    if (pg_md5_hash(VARDATA_ANY(in_text), len, hexsum) == false)
        ereport(ERROR,
                (errcode(ERRCODE_OUT_OF_MEMORY),
                 errmsg("out of memory")));

    /* convert to text and return it */
    PG_RETURN_TEXT_P(cstring_to_text(hexsum));
}

/*
 *  pg_md5_hash
 *
 *  Calculates the MD5 sum of the bytes in a buffer.
 *
 *  SYNOPSIS      #include "md5.h"
 *                int pg_md5_hash(const void *buff, size_t len, char *hexsum)
 *
 *  INPUT         buff    the buffer containing the bytes that you want
 *                        the MD5 sum of.
 *                len     number of bytes in the buffer.
 *
 *  OUTPUT        hexsum  the MD5 sum as a '\0'-terminated string of
 *                        hexadecimal digits.  an MD5 sum is 16 bytes long.
 *                        each byte is represented by two heaxadecimal
 *                        characters.  you thus need to provide an array
 *                        of 33 characters, including the trailing '\0'.
 *
 *  RETURNS       false on failure (out of memory for internal buffers) or
 *                true on success.
 *
 *  STANDARDS     MD5 is described in RFC 1321.
 *
 *  AUTHOR        Sverre H. Huseby &lt;sverrehu@online.no&gt;
 *
 */
bool
pg_md5_hash(const void *buff, size_t len, char *hexsum)
{
    uint8       sum[16];

    if (!calculateDigestFromBuffer(buff, len, sum))
        return false;

    bytesToHex(sum, hexsum);
    return true;
}

static int
calculateDigestFromBuffer(const uint8 *b, uint32 len, uint8 sum[16])
{
    register uint32 i,
                j,
                k,
                newI;
    uint32      l;
    uint8      *input;
    register uint32 *wbp;
    uint32      workBuff[16],
                state[4];

    l = len;

    state[0] = 0x67452301;
    state[1] = 0xEFCDAB89;
    state[2] = 0x98BADCFE;
    state[3] = 0x10325476;

    if ((input = createPaddedCopyWithLength(b, &amp;l)) == NULL)
        return 0;

    for (i = 0;;)
    {
        if ((newI = i + 16 * 4) &gt; l)
            break;
        k = i + 3;
        for (j = 0; j &lt; 16; j++)
        {
            wbp = (workBuff + j);
            *wbp = input[k--];
            *wbp &lt;&lt;= 8;
            *wbp |= input[k--];
            *wbp &lt;&lt;= 8;
            *wbp |= input[k--];
            *wbp &lt;&lt;= 8;
            *wbp |= input[k];
            k += 7;
        }
        doTheRounds(workBuff, state);
        i = newI;
    }
    free(input);

    j = 0;
    for (i = 0; i &lt; 4; i++)
    {
        k = state[i];
        sum[j++] = (k &amp; 0xff);
        k &gt;&gt;= 8;
        sum[j++] = (k &amp; 0xff);
        k &gt;&gt;= 8;
        sum[j++] = (k &amp; 0xff);
        k &gt;&gt;= 8;
        sum[j++] = (k &amp; 0xff);
    }
    return 1;
}

</code></pre>
<pre><code>postgres=# select length(md5(random()::text)),md5(random()::text) from generate_series(1,10);
 length |               md5
--------+----------------------------------
     32 | 4b0fcafd0f9d189cceade2812e4aa396
     32 | 9169f49f0c059a65de3325a20068eb8e
     32 | 7df4b60638972f1372fde91e3d2eee50
     32 | 4fc6816aa88224163dda3e242f3e16f0
     32 | 518870a2c8a9cfe6cba018916f5388a9
     32 | b46b63c409532e5c973ddc27a5e49ce4
     32 | e24e9d63926094046aa2b300dfa8e986
     32 | 3f1ca7c5ce5159a0df17729f81e24925
     32 | 5756f0925eca4c3801c4a49cf9b68023
     32 | ed54795fcbe9491f4e5a00ec2cf323ee
(10 rows)
另外，截取前8位的目的是生成一个8位长的随机字符串，在车牌，QQ，条形码等数据类型中长度的一个折中。
其实要测试16或32位长的随机字符串也可以的，我稍后更新一下对应长度的测试数据。
感谢您的关注。
还有一些PG文章推荐给您，了解一下PostgreSQL：
高并发的优化
http://blog.163.com/digoal@126/blog/static/16387704020159853541614/
秒杀性能调优
http://blog.163.com/digoal@126/blog/static/16387704020158149538415/
每天万亿级记录流式处理
http://blog.163.com/digoal@126/blog/static/1638770402015111543639382/
百亿级数据量地理位置检索
http://blog.163.com/digoal@126/blog/static/163877040201601875129497/
水平分片
http://blog.163.com/digoal@126/blog/static/16387704020161239252998/
数字计算CPU硬解
http://blog.163.com/digoal@126/blog/static/1638770402016237454462/
PG的优化器逻辑推理能力源码剖析
http://blog.163.com/digoal@126/blog/static/163877040201612374931160/
TPC-C 极限调优
https://github.com/digoal/pgsql_admin_script/blob/master/pgsql_perf_tuning
</code></pre>
<p>以下是32字符长的测试<br />
单机10亿 32位长度 正则，模糊检索 性能图表：<br /><a href="http://img1.tbcdn.cn/L1/461/1/c19de3f9b4a8da62f0678ffdb2eb004c4d1a4e5b.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS50YmNkbi5jbi9MMS80NjEvMS9jMTlkZTNmOWI0YThkYTYyZjA2NzhmZmRiMmViMDA0YzRkMWE0ZTViLnBuZw==.jpg"></a></p>
<p>详细记录：<br />
插入10亿数据，每条记录存储32位长随机字符串。</p>
<pre><code>postgres=# create table t_regexp (info text);
CREATE TABLE
postgres=# insert into t_regexp select md5(random()::text) from generate_series(1,1000000000);
INSERT 0 1000000000
postgres=# create index idx_t_regexp_gin on t_regexp using gin (info gin_trgm_ops);
CREATE INDEX
postgres=# create index idx_t_regexp_1 on t_regexp (info);
CREATE INDEX
postgres=# create index idx_t_regexp_2 on t_regexp (reverse(info));
CREATE INDEX
</code></pre>
<p>使用auto_explain收集性能测试数据:</p>
<pre><code>load 'auto_explain';
set auto_explain.log_analyze =true;
set auto_explain.log_buffers =true;
set auto_explain.log_nested_statements=true;
set auto_explain.log_timing=true;
set auto_explain.log_triggers=true;
set auto_explain.log_verbose=true;
set auto_explain.log_min_duration=0;
set client_min_messages ='log';
set work_mem='2GB';
</code></pre>
<p>测试数据概貌，总记录数10亿, 唯一数约8亿 如下：</p>
<pre><code>digoal=&gt; select count(*) from t_regexp ;
   count
------------
 1000000000
(1 row)
Time: 18547.746 ms  

digoal=&gt; select count(*) from (select info from t_regexp group by info) t;
   count
-----------
 799444838
(1 row)
</code></pre>
<p>带前缀模糊查询性能<br />
有结果性能</p>
<pre><code>digoal=# select ctid,* from t_regexp where info ~ '^9def5fe6343a5938b23af38444b7e' limit 10;
LOG:  duration: 0.351 ms  plan:
Query Text: select ctid,* from t_regexp where info ~ '^9def5fe6343a5938b23af38444b7e' limit 10;
Limit  (cost=0.15..8.17 rows=1 width=39) (actual time=0.152..0.346 rows=2 loops=1)
  Output: ctid, info
  -&gt;  Remote Subquery Scan on all (data1,data10,data11,data12,data13,data14,data15,data16,data2,data3,data4,data5,data6,data7,data8,data9)  (cost=0.15..8.17 rows=1 width=39) (actual time=0.150..0.342 rows=2 loops=1)
        Output: ctid, info
     ctid     |               info
--------------+----------------------------------
 (14720,1)    | 9def5fe6343a5938b23af38444b7e350
 (379127,105) | 9def5fe6343a5938b23af38444b7e350
(2 rows)
Time: 7.952 ms
</code></pre>
<p>无结果性能</p>
<pre><code>digoal=# select ctid,* from t_regexp where info ~ '^9def5fe6343a5938b23af38444b7a' limit 10;
LOG:  duration: 0.447 ms  plan:
Query Text: select ctid,* from t_regexp where info ~ '^9def5fe6343a5938b23af38444b7a' limit 10;
Limit  (cost=0.15..8.17 rows=1 width=39) (actual time=0.443..0.443 rows=0 loops=1)
  Output: ctid, info
  -&gt;  Remote Subquery Scan on all (data1,data10,data11,data12,data13,data14,data15,data16,data2,data3,data4,data5,data6,data7,data8,data9)  (cost=0.15..8.17 rows=1 width=39) (actual time=0.441..0.441 rows=0 loops=1)
        Output: ctid, info
 ctid | info
------+------
(0 rows)
Time: 7.968 ms
</code></pre>
<p>带后缀模糊查询性能<br />
有结果性能</p>
<pre><code>digoal=# select ctid,* from t_regexp where reverse(info) ~ '^1e346e5efc7703f11495';
LOG:  duration: 5.287 ms  plan:
Query Text: select ctid,* from t_regexp where reverse(info) ~ '^1e346e5efc7703f11495';
Remote Fast Query Execution  (cost=0.00..0.00 rows=0 width=0) (actual time=4.943..5.281 rows=1 loops=1)
  Output: t_regexp.ctid, t_regexp.info
  Node/s: data1, data10, data11, data12, data13, data14, data15, data16, data2, data3, data4, data5, data6, data7, data8, data9
  Remote query: SELECT ctid, info FROM t_regexp WHERE (reverse(info) ~ '^1e346e5efc7703f11495'::text)
    ctid    |               info
------------+----------------------------------
 (19928,46) | cc302768b6a459411f3077cfe5e643e1
(1 row)
Time: 6.079 ms
</code></pre>
<p>无结果性能</p>
<pre><code>digoal=# select ctid,* from t_regexp where reverse(info) ~ '^1e346e5efc7703f11495123';
LOG:  duration: 4.157 ms  plan:
Query Text: select ctid,* from t_regexp where reverse(info) ~ '^1e346e5efc7703f11495123';
Remote Fast Query Execution  (cost=0.00..0.00 rows=0 width=0) (actual time=4.154..4.154 rows=0 loops=1)
  Output: t_regexp.ctid, t_regexp.info
  Node/s: data1, data10, data11, data12, data13, data14, data15, data16, data2, data3, data4, data5, data6, data7, data8, data9
  Remote query: SELECT ctid, info FROM t_regexp WHERE (reverse(info) ~ '^1e346e5efc7703f11495123'::text)
 ctid | info
------+------
(0 rows)
Time: 4.930 ms
</code></pre>
<p>前后模糊查询性能<br />
有结果性能</p>
<pre><code>digoal=# select ctid,* from t_regexp where info ~ '6ccd8ca827b0526cd57a71c949' order by info &lt;-&gt; '6ccd8ca827b0526cd57a71c949' limit 10;
LOG:  duration: 3066.193 ms  plan:
Query Text: select ctid,* from t_regexp where info ~ '6ccd8ca827b0526cd57a71c949' order by info &lt;-&gt; '6ccd8ca827b0526cd57a71c949' limit 10;
Limit  (cost=72.03..72.03 rows=1 width=39) (actual time=3066.175..3066.176 rows=1 loops=1)
  Output: ctid, info, ((info &lt;-&gt; '6ccd8ca827b0526cd57a71c949'::text))
  -&gt;  Remote Subquery Scan on all (data1,data10,data11,data12,data13,data14,data15,data16,data2,data3,data4,data5,data6,data7,data8,data9)  (cost=72.03..72.03 rows=1 width=39) (actual time=3066.173..3066.174 rows=1 loops=1)
        Output: ctid, info, (info &lt;-&gt; '6ccd8ca827b0526cd57a71c949'::text)
    ctid      |               info
--------------+----------------------------------
 (459019,106) | 8536ccd8ca827b0526cd57a71c949ab2
(1 row)
Time: 3074.907 ms
</code></pre>
<p>无结果性能</p>
<pre><code>digoal=# select ctid,* from t_regexp where info ~ '6ccd8ca827b0526cd57a71c123' order by info &lt;-&gt; '6ccd8ca827b0526cd57a71c123' limit 10;
LOG:  duration: 3099.348 ms  plan:
Query Text: select ctid,* from t_regexp where info ~ '6ccd8ca827b0526cd57a71c123' order by info &lt;-&gt; '6ccd8ca827b0526cd57a71c123' limit 10;
Limit  (cost=72.03..72.03 rows=1 width=39) (actual time=3099.341..3099.341 rows=0 loops=1)
  Output: ctid, info, ((info &lt;-&gt; '6ccd8ca827b0526cd57a71c123'::text))
  -&gt;  Remote Subquery Scan on all (data1,data10,data11,data12,data13,data14,data15,data16,data2,data3,data4,data5,data6,data7,data8,data9)  (cost=72.03..72.03 rows=1 width=39) (actual time=3099.339..3099.339 rows=0 loops=1)
        Output: ctid, info, (info &lt;-&gt; '6ccd8ca827b0526cd57a71c123'::text)
 ctid | info
------+------
(0 rows)
Time: 3108.698 ms
</code></pre>
<p>使用了GIN索引</p>
<pre><code>digoal=# explain (verbose) select ctid,* from t_regexp where info ~ '6ccd8ca827b0526cd57a71c123' order by info &lt;-&gt; '6ccd8ca827b0526cd57a71c123' limit 10;
LOG:  duration: 0.000 ms  plan:
Query Text: explain (verbose) select ctid,* from t_regexp where info ~ '6ccd8ca827b0526cd57a71c123' order by info &lt;-&gt; '6ccd8ca827b0526cd57a71c123' limit 10;
Limit  (cost=72.03..72.03 rows=1 width=39)
  Output: ctid, info, ((info &lt;-&gt; '6ccd8ca827b0526cd57a71c123'::text))
  -&gt;  Remote Subquery Scan on all (data1,data10,data11,data12,data13,data14,data15,data16,data2,data3,data4,data5,data6,data7,data8,data9)  (cost=72.03..72.03 rows=1 width=39)
        Output: ctid, info, (info &lt;-&gt; '6ccd8ca827b0526cd57a71c123'::text)
        -&gt;  Limit  (cost=72.03..72.03 rows=1 width=39)
              Output: ctid, info, ((info &lt;-&gt; '6ccd8ca827b0526cd57a71c123'::text))
              -&gt;  Sort  (cost=72.03..72.03 rows=1 width=39)
                    Output: ctid, info, ((info &lt;-&gt; '6ccd8ca827b0526cd57a71c123'::text))
                    Sort Key: ((t_regexp.info &lt;-&gt; '6ccd8ca827b0526cd57a71c123'::text))
                    -&gt;  Bitmap Heap Scan on public.t_regexp  (cost=68.00..72.02 rows=1 width=39)
                          Output: ctid, info, (info &lt;-&gt; '6ccd8ca827b0526cd57a71c123'::text)
                          Recheck Cond: (t_regexp.info ~ '6ccd8ca827b0526cd57a71c123'::text)
                          -&gt;  Bitmap Index Scan on idx_t_regexp_gin  (cost=0.00..68.00 rows=1 width=0)
                                Index Cond: (t_regexp.info ~ '6ccd8ca827b0526cd57a71c123'::text)
</code></pre>
<p>正则匹配查询性能<br />
有结果性能(例如0和8,B,6和b混淆)</p>
<pre><code>digoal=# select ctid,* from t_regexp where info ~ 'b44c9616bfa[8|0|B]6a722daa9596f86e[b|6]efb' order by info &lt;-&gt; 'b44c9616bfa[8|0|B]6a722daa9596f86e[b|6]efb' limit 10;
LOG:  duration: 3181.592 ms  plan:
Query Text: select ctid,* from t_regexp where info ~ 'b44c9616bfa[8|0|B]6a722daa9596f86e[b|6]efb' order by info &lt;-&gt; 'b44c9616bfa[8|0|B]6a722daa9596f86e[b|6]efb' limit 10;
Limit  (cost=72.03..72.03 rows=1 width=39) (actual time=3181.568..3181.569 rows=2 loops=1)
  Output: ctid, info, ((info &lt;-&gt; 'b44c9616bfa[8|0|B]6a722daa9596f86e[b|6]efb'::text))
  -&gt;  Remote Subquery Scan on all (data1,data10,data11,data12,data13,data14,data15,data16,data2,data3,data4,data5,data6,data7,data8,data9)  (cost=72.03..72.03 rows=1 width=39) (actual time=3181.566..3181.566 rows=2 loops=1)
        Output: ctid, info, (info &lt;-&gt; 'b44c9616bfa[8|0|B]6a722daa9596f86e[b|6]efb'::text)
     ctid     |               info
--------------+----------------------------------
 (260416,110) | b44c9616bfa86a722daa9596f86ebefb
 (504007,4)   | b44c9616bfa86a722daa9596f86ebefb
(2 rows)
Time: 3189.666 ms
</code></pre>
<p>又如再加难度，中间忘记了几个字符，只知道是数字，并且可能是2到5个数字</p>
<pre><code>digoal=# select ctid,* from t_regexp where info ~ 'b44c9616bfa[8|0|B]6a722daa[\d]{2,5}6f86e[b|6]efb' order by info &lt;-&gt; 'b44c9616bfa[8|0|B]6a722daa[0-9]{2,5}6f86e[b|6]efb' limit 10;
LOG:  duration: 3249.156 ms  plan:
Query Text: select ctid,* from t_regexp where info ~ 'b44c9616bfa[8|0|B]6a722daa[\d]{2,5}6f86e[b|6]efb' order by info &lt;-&gt; 'b44c9616bfa[8|0|B]6a722daa[0-9]{2,5}6f86e[b|6]efb' limit 10;
Limit  (cost=72.03..72.03 rows=1 width=39) (actual time=3249.136..3249.137 rows=2 loops=1)
  Output: ctid, info, ((info &lt;-&gt; 'b44c9616bfa[8|0|B]6a722daa[0-9]{2,5}6f86e[b|6]efb'::text))
  -&gt;  Remote Subquery Scan on all (data1,data10,data11,data12,data13,data14,data15,data16,data2,data3,data4,data5,data6,data7,data8,data9)  (cost=72.03..72.03 rows=1 width=39) (actual time=3249.134..3249.134 rows=2 loops=1)
        Output: ctid, info, (info &lt;-&gt; 'b44c9616bfa[8|0|B]6a722daa[0-9]{2,5}6f86e[b|6]efb'::text)
     ctid     |               info
--------------+----------------------------------
 (260416,110) | b44c9616bfa86a722daa9596f86ebefb
 (504007,4)   | b44c9616bfa86a722daa9596f86ebefb
(2 rows)
Time: 3257.435 ms
</code></pre>
<p>无结果性能</p>
<pre><code>digoal=# select ctid,* from t_regexp where info ~ 'b44c9616bfa[8|0|B]6a722daa9596f86e[b|6]e12' order by info &lt;-&gt; 'b44c9616bfa[8|0|B]6a722daa9596f86e[b|6]e12' limit 10;
LOG:  duration: 3086.572 ms  plan:
Query Text: select ctid,* from t_regexp where info ~ 'b44c9616bfa[8|0|B]6a722daa9596f86e[b|6]e12' order by info &lt;-&gt; 'b44c9616bfa[8|0|B]6a722daa9596f86e[b|6]e12' limit 10;
Limit  (cost=72.03..72.03 rows=1 width=39) (actual time=3086.567..3086.567 rows=0 loops=1)
  Output: ctid, info, ((info &lt;-&gt; 'b44c9616bfa[8|0|B]6a722daa9596f86e[b|6]e12'::text))
  -&gt;  Remote Subquery Scan on all (data1,data10,data11,data12,data13,data14,data15,data16,data2,data3,data4,data5,data6,data7,data8,data9)  (cost=72.03..72.03 rows=1 width=39) (actual time=3086.565..3086.565 rows=0 loops=1)
        Output: ctid, info, (info &lt;-&gt; 'b44c9616bfa[8|0|B]6a722daa9596f86e[b|6]e12'::text)
 ctid | info
------+------
(0 rows)
Time: 3094.683 ms
</code></pre>
<p>多机 1000亿级别的性能测试，下周发出。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:38:19</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/postgresql/" title="PostgreSQL">PostgreSQL</a>, <a href="https://www.iamivan.net/tag/%e5%a4%a7%e6%95%b0%e6%8d%ae/" title="大数据">大数据</a>, <a href="https://www.iamivan.net/tag/%e6%ad%a3%e5%88%99%e5%8c%b9%e9%85%8d/" title="正则匹配">正则匹配</a>, <a href="https://www.iamivan.net/tag/%e6%a8%a1%e7%b3%8a%e5%8c%b9%e9%85%8d/" title="模糊匹配">模糊匹配</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>PostgreSQL 百亿数据 秒级响应 正则及模糊查询的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdmav1z.html" rel="bookmark">如何将日志服务的数据秒级同步到表格存储</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近在容器服务的官方镜像中,新增了loghub-shipper的镜像,使用该镜像,可以订阅日志服务中的日志库,以秒级的延时将日志数据从日志服务中读出并转换成结构化数据存储在表格存储中,以满足实时在线服务的精确查询需求. 什么是日志服务? 日志服务(Log Service,Log)是针对日志场景的一站式解决方案,解决海量日志数据采集/订阅.转储与查询功能,比如在海量游戏日志收集与分析场景上的应用. 什么是表格存储? 表格存储(TableStore)提供海量NoSQL数据的存储与实时访问服务,能够支			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze6B5wb.html" rel="bookmark">阿里EB级大数据体系，如何做到秒级响应、高效赋能？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				阿里巴巴如何构建一个从底层的数据采集.处理,到挖掘算法.应用.产品服务的全链路.标准化的大数据体系,使得超过EB级别的海量数据能够高效融合,并以秒级的响应速度,服务并驱动阿里巴巴的业务和外部千万用户的发展?阿里巴巴数据技术及产品部资深技术专家姚滨晖,在2017云栖大会上做了一次非常精彩的分享,今天我们一起来重温. 总体来看,阿里巴巴的生态可以分为六个业务板块:电商.物流.健康.文娱.金融,以及云计算.阿里巴巴通过这些业务,服务了数亿用户,上千万的小微企业,以及上千万的商家.伴随着我们的业务服务,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My3vBlz.html" rel="bookmark">PostgreSQL 1000亿数据量 正则匹配 速度与激情</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				承接上一篇https://yq.aliyun.com/articles/7444 测试环境为 8台主机(16c/host)的 PostgreSQL集群,一共240个数据节点,测试数据量1008亿.性能图表 : 如果要获得更快的响应速度,可以通过增加主机和节点数(或者通过增加CPU和节点数),缩短recheck的处理时间. 数据生成方法: #!/bin/bash # 截取通过random()计算得到的MD5 128bit hex的前48bit, 转成字符串,得到[0-9]和[a-f]组成的12个随			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2PJYqp.html" rel="bookmark">PostgreSQL 百亿级数据范围查询&comma; 分组排序窗口取值 极致优化 case</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文将对一个任意范围按ID分组查出每个ID对应的最新记录的CASE做一个极致的优化体验.优化后性能维持在可控范围内,任意数据量,毫秒级返回,性能平稳可控.比优化前性能提升1万倍. CASE 有一张数据表,结构: CREATE TABLE target_position ( target_id varchar(80), time bigint, content text ); 数据量是 100 亿条左右 target_id 大约 20 万个 数据库使用的是 PostgreSQL 9.4 需求: 查			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLmOVZz.html" rel="bookmark">mysql正则匹配模糊查询的例子</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MySQL仅支持多数正则表达式实现的一个很小的子集. ---------------------- 9.2.1  基本字符匹配 REGEXP后所跟的东西作为正则表达式处理.   SELECT prod_name FROM products WHERE prod_name REGEXP '1000' ORDER BY prod_name; ------返回------ +------------------------+ |    prod_name    | +-----------------			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MArZRAp.html" rel="bookmark">PostgreSQL 百亿地理位置数据 近邻查询性能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				背景 本文主要要展示的是PostgreSQL在位置信息近邻(KNN)查询方面的性能. 测试类型point,索引类型GiST. (PostGIS同样支持KNN查询,性能和本文的测试差不多)  测试数据量大于100亿. 结果 64个并发,随机选点,单次KNN查询请求的平均响应时间为0.848毫秒. 测试环境和优化请参考 http://blog.163.com/digoal@126/blog/static/16387704020160941345888/ 创建测试表 postgres=# create			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwx11mb.html" rel="bookmark">PostgreSQL 全表 全字段 模糊查询的毫秒级高效实现 - 搜索引擎也颤抖了</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				标签 PostgreSQL , 分词 , 全文检索 , 全字段检索 , 任意字段检索 , 下拉框选择 , 搜索引擎 背景 在一些应用程序中,可能需要对表的所有字段进行检索,有些字段可能需要精准查询,有些字段可能需要模糊查询或全文检索. 比如一些前端页面下拉框的勾选和选择. 这种需求对于应用开发人员来说,会很蛋疼,因为写SQL很麻烦,例子: 之前写过一篇文章来解决这个问题 &lt;PostgreSQL 行级 全文检索&gt; 使用的是全文检索,而当用户的需求为模糊查询时? 如何来解决呢? 不难想到我之前写过			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPPeJvp.html" rel="bookmark">中文模糊查询性能优化 by PostgreSQL trgm</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前模糊,后模糊,前后模糊,正则匹配都属于文本搜索领域常见的需求.PostgreSQL在文本搜索领域除了全文检索,还有trgm是一般数据库没有的,甚至可能很多人没有听说过.对于前模糊和后模糊,PG则与其他数据库一样,可以使用btree来加速,后模糊可以使用反转函数的函数索引来加速.对于前后模糊和正则匹配,则可以使用trgm,TRGM是一个非常强的插件,对这类文本搜索场景性能提升非常有效,100万左右的数据量,性能提升有500倍以上. 例子:生成100万数据 postgres=# create ta			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnKWwAz.html" rel="bookmark">云南龙江特大桥通车 高德地图实现秒级上线</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&quot;龙江两岸秋色浓,大桥合龙峡谷通.&quot;4月20日上午10点48分,云南保腾高速公路上的重要控制性工程--云南保山龙江特大桥正式通车.大桥通车后,从昆明到腾冲实现了全程高速,7小时左右即可抵达,为打通昆明经腾冲出境经缅甸至印度陆上大通道奠定了基础. 而在龙江大桥通车之际,高德地图也宣布,已经独家率先完成对保山龙江大桥及保腾高速道路信息的采集,并在几乎大桥通车的同时就对高德地图中该路段的信息进行了更新,全面实现了秒级上线.基于新的道路数据,用户可即时在高德地图上查到龙江大桥及保腾高速的全新道			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBk49M.html" rel="bookmark" class="title">系统中的Hosts文件</a>
					<div>
						在linux 系统中有个Hosts文件/etc/hosts 对Windows系统稍微熟悉点的朋友都知道,在Window系统中有个Hosts文件,在Windows 2000/XP系统中位于C:\Wind ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8LrPp.html" rel="bookmark" class="title">互联网产品设计&colon;从短信看产品设计</a>
					<div>
						文章描述:从移动短消息看产品设计. 今日收到移动短消息,内容如下: 尊敬的动感地带客户,截至3月10日,您的客户M值为947分.PC登录jf.10086.cn或手机登陆wap.jf.10086.cn畅 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrJAWM.html" rel="bookmark" class="title">photoshop快速调出照片柔美的黄绿色</a>
					<div>
						本教程的调色方法非常快捷实用.调色步骤不多,用到一些填充色及几个简单的调色工具.出来的效果还蛮不错.可以参考一下. 本教程的调色方法非常快捷实用.调色步骤不多,用到一些填充色及几个简单的调色工具.出来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxnw2b.html" rel="bookmark" class="title">C&plus;&plus;字符串完全指引之一：Win32 字符编码</a>
					<div>
						引言 毫无疑问,我们都看到过像 TCHAR, std::string, BSTR 等各种各样的字符串类型,还有那些以 _tcs 开头的奇怪的宏.你也许正在盯着显示器发愁.本指引将总结引进各种字符类型的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDA3Vlb.html" rel="bookmark" class="title">C&num;实现快速排序法</a>
					<div>
						快速排序法是对冒泡排序的一种改进.它的基本思想是,通过一趟排序将待排序记录分割成独立的两部分,其中一部分记录的关键字均比另一部分记录的关键字小,则可分别对这两部分记录继续进行排序,以达到整个序列有序. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK79Vdb.html" rel="bookmark" class="title">Flash也能制作特色小图标</a>
					<div>
						  地震这几天邻居家小孩天天不上课闹着要教他Flash.正好,好久也没做教程了拿出来分享一下吧,纯给新人练手,老鸟可以飞了.效果图如下: 第一步:先做橡皮那块.新建图层用矩形工具上圆角改为5,5下圆角 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYjyKb.html" rel="bookmark" class="title">node&period;js中RPC&lpar;远程过程调用&rpar;的实现原理介绍</a>
					<div>
						  使用示例: 代码如下: //服务端 var light_rpc = require('./index.js'); var port = 5556; var rpc = new light_rpc( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bad5Zqz.html" rel="bookmark" class="title">如何解决开始菜单下级栏目响应速度过慢的问题</a>
					<div>
						  开始菜单的弹出速度是可以控制的,我们可以在控制面板中对它进行修改:打开注册表编辑器,依次展开HKEY_CURRENT_USERControlPaneldesktop分支,然后在此创建一个DWORD ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEr7xz.html" rel="bookmark" class="title">微软拟投入5亿美元推广Windows Phone 7</a>
					<div>
						北京时间8月27日午间消息,据国外媒体报道,分析人士预计,微软将投入5亿多美元启动Windows Phone 7计划,借此重新打入手机市场. 在苹果推出iPhone近4年以及谷歌开放Adroid操作系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1l57ab.html" rel="bookmark" class="title">ODPS功能介绍之数据导入</a>
					<div>
						在使用ODPS强大的数据处理能力之前,大家最关心的是自己的数据如何导入到ODPS中. 下面介绍一款向ODPS导入数据的工具-Fluentd. Fluentd是一个开源的软件,用来收集各种源头日志(包括 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlxYGp.html" rel="bookmark" class="title">如何点Button按钮后打开一个应用程序呢？（C&num;）</a>
					<div>
						问题描述 希望大家帮助,急用........... 解决方案 解决方案二:你是什么结构的?如果是winform,从注册表里读取这类文件打开的关联程序,根据程序的路径,用shell语句执行.如果是应用程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKx6Yb.html" rel="bookmark" class="title">c&plus;&plus;类模板可以前置声明吗</a>
					<div>
						问题描述 c++类模板可以前置声明吗 c++类模板可以前置声明吗?格式是什么样的?有不能前置声明的吗?在.h文件中前置声明,在.cpp中include 解决方案 无非就是 templete &lt;t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWj0nz.html" rel="bookmark" class="title">【视觉目标跟踪最高峰】VOT Challenge 2017 亚军北邮团队技术分享（附代码）</a>
					<div>
						视觉跟踪领域国际顶级赛事 Visual-Object-Tracking Challenge (VOT) 2017年结果出炉,结合传统滤波及深度学习的方案取得最佳成绩.本文是第二名北京邮电大学代表团队的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rldAz.html" rel="bookmark" class="title">跟老男孩学Linux运维：Shell编程实战2&period;6　Shell脚本的建立和执行</a>
					<div>
						2.6 Shell脚本的建立和执行 2.6.1 Shell脚本的建立 在Linux系统中,Shell脚本(bash Shell程序)通常是在编辑器vi/vim中编写的,由UNIX/Linux命令.ba ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRen2p.html" rel="bookmark" class="title">unity &plus; mfc  socket通信问题</a>
					<div>
						问题描述 unity + mfc socket通信问题 新手小白.. 用MFC串口通信写了一个读取GPS仪器数据的程序,想用读取的GPS数据作为位置数据控制unity中物体的运动.Unity与C++之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1qoAz.html" rel="bookmark" class="title">linux中bash&colon; wget&colon; command not found问题解决方法</a>
					<div>
						一般linux最小化安装时,wget不会默认被安装. 提示bash: xx command not found. 那么,首先就要考虑root 的$PATH里是否已经包含了这些环境变量(可能是我安装的时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJA5oDp.html" rel="bookmark" class="title">myeclipse显示图面问题</a>
					<div>
						问题描述 我是个初学者,不知道怎么显示图面啊?直接附加进去就行了吗?格式是什么?要加载什么包吗?请大家详细说明下~ 解决方案 解决方案二:什么教图面是图片吗拖拽解决方案三:图片?直接粘贴啊,引用的时候 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8A1VZz.html" rel="bookmark" class="title">这篇 感觉很实用--DJANGO ORM</a>
					<div>
						Django之model F/Q以及多对多操作 http://www.cnblogs.com/ccorz/p/5882400.html model之F/Q操作 F操作,使用查询条件的值 打个比方吧,有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBdgXM.html" rel="bookmark" class="title">Google莫斯科温暖的家庭的办公环境</a>
					<div>
						当 http://www.aliyun.com/zixun/aggregation/1564.html&quot;&gt;Google准备决定设计科办公室的时候,他们不是随意买来好多软靠垫.滑梯和乒乓 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBkqnM.html" rel="bookmark" class="title">android fragment点击返回键实现内容切换？</a>
					<div>
						问题描述 android fragment点击返回键实现内容切换? 我有一个fragment,上有一个button和textview,默认button是隐藏的,通过点击菜单栏上的一个详细信息的按钮,将 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLg3EZM.html" rel="bookmark" class="title">微软推苹果AirPlay类似 应用</a>
					<div>
						近日,据国外媒体报道,有消息称微软将在即将举行的E3展会上推出一款名为Xbox Smart Glass的Xbox 360应用,该应用与苹果AirPlay类似,至于该应用的前景如何,还需我们拭目以待.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9x80db.html" rel="bookmark" class="title">iOS环信demo的数据库名字叫什么？</a>
					<div>
						问题描述 解决方案 app/library/easemobDB文件夹下解决方案二: 解决方案三: 解决方案四:就是你的当前手机饿app有两个登陆过得用户了,一个用户是19,另外一个是46解决方案五:现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWr38z.html" rel="bookmark" class="title">中资入股友邦保险可能夭折三家企业抱团进退</a>
					<div>
						李关云 8月12日,本报记者通过投行界可靠渠道获悉,由于友邦保险股权(AIA)报价过高,此前与其紧锣密鼓进行股权收购谈判的多家中资机构打算联合退出.AIA是美国国际集团(AIG)旗下主营亚洲寿险业务的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmW86z.html" rel="bookmark" class="title">java序列化和java反序列化示例&lowbar;java</a>
					<div>
						序列化一般应用与以下场景之中:1.永久性保存对象,把对象通过序列化字节流保存到本地文件中:2.通过序列化在网络中传输对象3.通过序列化在进程间传递对象 复制代码 代码如下: import java.i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2keaz.html" rel="bookmark" class="title">深入浅析JavaScript中的3DES&lowbar;javascript技巧</a>
					<div>
						3DES简介: 3DES(或称为Triple DES)是三重数据加密算法(TDEA,Triple Data Encryption Algorithm)块密码的通称.它相当于是对每个数据块应用三次DES ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBke5KM.html" rel="bookmark" class="title">hbase shell error&colon;MasterNotRunningException&colon; Retried 7 times</a>
					<div>
						问题描述 操作系统:suselinuxserver11sp3hadoop版本:2.2.0hbase版本:0.94.16zookeeper版本:3.4.5hadoop,yarn,zookeeper,hb ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkaoJM.html" rel="bookmark" class="title">java byte&lbrack;&rsqb;类型 base64解密</a>
					<div>
						问题描述 首先我从服务器得到shippinglablepdf.getPdfData()得到的是一个JPG加密后的byte[]我需要对改图片进行解密后 保存到本地我想是解密是不能先转换String 不然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK03kEM.html" rel="bookmark" class="title">SQL 无限级分类语句</a>
					<div>
						原文:SQL 无限级分类语句 原表数据为:   此处用到了with关键字,在程序中也可以用递归实现,但觉得还是没有一条sql方便 with tb (ID,Name,ParentID,Sort) as( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAoyYp.html" rel="bookmark" class="title">进入DRF和ANGULAR的整合学习，这三篇入门内容一定要学好的</a>
					<div>
						看来,DJANGO的模板功能是无法用啦, 学着用ANGLUAR的SERVICE,MODULE,CONTROLLER啦... http://engineroom.trackmaven.com/blog/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrvYnxM.html" rel="bookmark" class="title">完全支持jdk1&period;5的eclipse的版本？</a>
					<div>
						问题描述 不要回答的太笼统,更不要答非所问,最好是自己用过体验过的,麻烦大神们了! 解决方案 解决方案二:额,家里有一个2010年冬天同事给的eclipse搭配jdk1.5的环境,现在应该还在.楼主如 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.051 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
